javax.annotation.PostConstruct issue when running with JDK11

classic Classic list List threaded Threaded
8 messages Options
Reply | Threaded
Open this post in threaded view
|

javax.annotation.PostConstruct issue when running with JDK11

Oleg Cohen
Greetings,

I am trying to run my Karaf application under JDK 11. I am getting the following exception:

Caused by: java.lang.ClassNotFoundException: javax.annotation.PostConstruct cannot be found by org.ops4j.pax.web.pax-web-jsp_7.2.3

It appears that the jigsaw module providing this package is not available in JDK 11. The suggestion is to use a dependency.

Wondering if anybody ran into this and what a solution/workaround might be.

Thank you!
Oleg
Reply | Threaded
Open this post in threaded view
|

Re: javax.annotation.PostConstruct issue when running with JDK11

jbonofre
Hi Oleg,

Correct, javax.annotation is available up to Java 10 (and even using
Java 10, the javax.annotation package has been splitted).

When using Java 11, you have to explicitly install either jsr305 or
javax.annotation jar files (it could be as private package of your
bundle, or ext lib).

Regards
JB

On 01/10/2018 17:14, Oleg Cohen wrote:

> Greetings,
>
> I am trying to run my Karaf application under JDK 11. I am getting the following exception:
>
> Caused by: java.lang.ClassNotFoundException: javax.annotation.PostConstruct cannot be found by org.ops4j.pax.web.pax-web-jsp_7.2.3
>
> It appears that the jigsaw module providing this package is not available in JDK 11. The suggestion is to use a dependency.
>
> Wondering if anybody ran into this and what a solution/workaround might be.
>
> Thank you!
> Oleg
>

--
Jean-Baptiste Onofré
[hidden email]
http://blog.nanthrax.net
Talend - http://www.talend.com
Reply | Threaded
Open this post in threaded view
|

Re: javax.annotation.PostConstruct issue when running with JDK11

Oleg Cohen
Thank you, JB!

In my case it is pax-web that can’t find the class, so I guess I need to add to ext lib. How can I add it? Should I do it at the JDK level or it is a mechanism in Karaf?

Thank you,
Oleg

> On Oct 1, 2018, at 11:33 AM, Jean-Baptiste Onofré <[hidden email]> wrote:
>
> Hi Oleg,
>
> Correct, javax.annotation is available up to Java 10 (and even using
> Java 10, the javax.annotation package has been splitted).
>
> When using Java 11, you have to explicitly install either jsr305 or
> javax.annotation jar files (it could be as private package of your
> bundle, or ext lib).
>
> Regards
> JB
>
> On 01/10/2018 17:14, Oleg Cohen wrote:
>> Greetings,
>>
>> I am trying to run my Karaf application under JDK 11. I am getting the following exception:
>>
>> Caused by: java.lang.ClassNotFoundException: javax.annotation.PostConstruct cannot be found by org.ops4j.pax.web.pax-web-jsp_7.2.3
>>
>> It appears that the jigsaw module providing this package is not available in JDK 11. The suggestion is to use a dependency.
>>
>> Wondering if anybody ran into this and what a solution/workaround might be.
>>
>> Thank you!
>> Oleg
>>
>
> --
> Jean-Baptiste Onofré
> [hidden email]
> http://blog.nanthrax.net
> Talend - http://www.talend.com

Reply | Threaded
Open this post in threaded view
|

Re: javax.annotation.PostConstruct issue when running with JDK11

jbonofre
Hi Oleg,

You can add at Karaf level (in the startup) or via dynamic-import on pax
web.

Regards
JB

On 01/10/2018 17:44, Oleg Cohen wrote:

> Thank you, JB!
>
> In my case it is pax-web that can’t find the class, so I guess I need to add to ext lib. How can I add it? Should I do it at the JDK level or it is a mechanism in Karaf?
>
> Thank you,
> Oleg
>
>> On Oct 1, 2018, at 11:33 AM, Jean-Baptiste Onofré <[hidden email]> wrote:
>>
>> Hi Oleg,
>>
>> Correct, javax.annotation is available up to Java 10 (and even using
>> Java 10, the javax.annotation package has been splitted).
>>
>> When using Java 11, you have to explicitly install either jsr305 or
>> javax.annotation jar files (it could be as private package of your
>> bundle, or ext lib).
>>
>> Regards
>> JB
>>
>> On 01/10/2018 17:14, Oleg Cohen wrote:
>>> Greetings,
>>>
>>> I am trying to run my Karaf application under JDK 11. I am getting the following exception:
>>>
>>> Caused by: java.lang.ClassNotFoundException: javax.annotation.PostConstruct cannot be found by org.ops4j.pax.web.pax-web-jsp_7.2.3
>>>
>>> It appears that the jigsaw module providing this package is not available in JDK 11. The suggestion is to use a dependency.
>>>
>>> Wondering if anybody ran into this and what a solution/workaround might be.
>>>
>>> Thank you!
>>> Oleg
>>>
>>
>> --
>> Jean-Baptiste Onofré
>> [hidden email]
>> http://blog.nanthrax.net
>> Talend - http://www.talend.com
>
Reply | Threaded
Open this post in threaded view
|

Re: javax.annotation.PostConstruct issue when running with JDK11

Oleg Cohen
In reply to this post by Oleg Cohen
Thank you, JB! I will give it a try.

Best
Oleg

Sent from my iPhone

> On Oct 1, 2018, at 11:57 AM, Jean-Baptiste Onofré <[hidden email]> wrote:
>
> Hi Oleg,
>
> You can add at Karaf level (in the startup) or via dynamic-import on pax
> web.
>
> Regards
> JB
>
>> On 01/10/2018 17:44, Oleg Cohen wrote:
>> Thank you, JB!
>>
>> In my case it is pax-web that can’t find the class, so I guess I need to add to ext lib. How can I add it? Should I do it at the JDK level or it is a mechanism in Karaf?
>>
>> Thank you,
>> Oleg
>>
>>> On Oct 1, 2018, at 11:33 AM, Jean-Baptiste Onofré <[hidden email]> wrote:
>>>
>>> Hi Oleg,
>>>
>>> Correct, javax.annotation is available up to Java 10 (and even using
>>> Java 10, the javax.annotation package has been splitted).
>>>
>>> When using Java 11, you have to explicitly install either jsr305 or
>>> javax.annotation jar files (it could be as private package of your
>>> bundle, or ext lib).
>>>
>>> Regards
>>> JB
>>>
>>>> On 01/10/2018 17:14, Oleg Cohen wrote:
>>>> Greetings,
>>>>
>>>> I am trying to run my Karaf application under JDK 11. I am getting the following exception:
>>>>
>>>> Caused by: java.lang.ClassNotFoundException: javax.annotation.PostConstruct cannot be found by org.ops4j.pax.web.pax-web-jsp_7.2.3
>>>>
>>>> It appears that the jigsaw module providing this package is not available in JDK 11. The suggestion is to use a dependency.
>>>>
>>>> Wondering if anybody ran into this and what a solution/workaround might be.
>>>>
>>>> Thank you!
>>>> Oleg
>>>>
>>>
>>> --
>>> Jean-Baptiste Onofré
>>> [hidden email]
>>> http://blog.nanthrax.net
>>> Talend - http://www.talend.com
>>
Reply | Threaded
Open this post in threaded view
|

Re: javax.annotation.PostConstruct issue when running with JDK11

jbonofre
Please let me know if you have any issue.

By the way, I'm preparing blog post + documentation update about how to
use Karaf on Java 10/11 and dealing with modules.

I created a Jira about that:

https://issues.apache.org/jira/browse/KARAF-5938

I also plan to add few examples about that (in karaf/examples).

Regards
JB

On 01/10/2018 19:18, Oleg Cohen wrote:

> Thank you, JB! I will give it a try.
>
> Best
> Oleg
>
> Sent from my iPhone
>
>> On Oct 1, 2018, at 11:57 AM, Jean-Baptiste Onofré <[hidden email]> wrote:
>>
>> Hi Oleg,
>>
>> You can add at Karaf level (in the startup) or via dynamic-import on pax
>> web.
>>
>> Regards
>> JB
>>
>>> On 01/10/2018 17:44, Oleg Cohen wrote:
>>> Thank you, JB!
>>>
>>> In my case it is pax-web that can’t find the class, so I guess I need to add to ext lib. How can I add it? Should I do it at the JDK level or it is a mechanism in Karaf?
>>>
>>> Thank you,
>>> Oleg
>>>
>>>> On Oct 1, 2018, at 11:33 AM, Jean-Baptiste Onofré <[hidden email]> wrote:
>>>>
>>>> Hi Oleg,
>>>>
>>>> Correct, javax.annotation is available up to Java 10 (and even using
>>>> Java 10, the javax.annotation package has been splitted).
>>>>
>>>> When using Java 11, you have to explicitly install either jsr305 or
>>>> javax.annotation jar files (it could be as private package of your
>>>> bundle, or ext lib).
>>>>
>>>> Regards
>>>> JB
>>>>
>>>>> On 01/10/2018 17:14, Oleg Cohen wrote:
>>>>> Greetings,
>>>>>
>>>>> I am trying to run my Karaf application under JDK 11. I am getting the following exception:
>>>>>
>>>>> Caused by: java.lang.ClassNotFoundException: javax.annotation.PostConstruct cannot be found by org.ops4j.pax.web.pax-web-jsp_7.2.3
>>>>>
>>>>> It appears that the jigsaw module providing this package is not available in JDK 11. The suggestion is to use a dependency.
>>>>>
>>>>> Wondering if anybody ran into this and what a solution/workaround might be.
>>>>>
>>>>> Thank you!
>>>>> Oleg
>>>>>
>>>>
>>>> --
>>>> Jean-Baptiste Onofré
>>>> [hidden email]
>>>> http://blog.nanthrax.net
>>>> Talend - http://www.talend.com
>>>

--
Jean-Baptiste Onofré
[hidden email]
http://blog.nanthrax.net
Talend - http://www.talend.com
Reply | Threaded
Open this post in threaded view
|

Re: javax.annotation.PostConstruct issue when running with JDK11

Oleg Cohen
Thank you, JB!

I got it to work successfully by adding lib/ext jar files to the classpath when launching Karaf (-classpath)

Best regards,
Oleg

> On Oct 1, 2018, at 1:42 PM, Jean-Baptiste Onofré <[hidden email]> wrote:
>
> Please let me know if you have any issue.
>
> By the way, I'm preparing blog post + documentation update about how to
> use Karaf on Java 10/11 and dealing with modules.
>
> I created a Jira about that:
>
> https://issues.apache.org/jira/browse/KARAF-5938
>
> I also plan to add few examples about that (in karaf/examples).
>
> Regards
> JB
>
> On 01/10/2018 19:18, Oleg Cohen wrote:
>> Thank you, JB! I will give it a try.
>>
>> Best
>> Oleg
>>
>> Sent from my iPhone
>>
>>> On Oct 1, 2018, at 11:57 AM, Jean-Baptiste Onofré <[hidden email]> wrote:
>>>
>>> Hi Oleg,
>>>
>>> You can add at Karaf level (in the startup) or via dynamic-import on pax
>>> web.
>>>
>>> Regards
>>> JB
>>>
>>>> On 01/10/2018 17:44, Oleg Cohen wrote:
>>>> Thank you, JB!
>>>>
>>>> In my case it is pax-web that can’t find the class, so I guess I need to add to ext lib. How can I add it? Should I do it at the JDK level or it is a mechanism in Karaf?
>>>>
>>>> Thank you,
>>>> Oleg
>>>>
>>>>> On Oct 1, 2018, at 11:33 AM, Jean-Baptiste Onofré <[hidden email]> wrote:
>>>>>
>>>>> Hi Oleg,
>>>>>
>>>>> Correct, javax.annotation is available up to Java 10 (and even using
>>>>> Java 10, the javax.annotation package has been splitted).
>>>>>
>>>>> When using Java 11, you have to explicitly install either jsr305 or
>>>>> javax.annotation jar files (it could be as private package of your
>>>>> bundle, or ext lib).
>>>>>
>>>>> Regards
>>>>> JB
>>>>>
>>>>>> On 01/10/2018 17:14, Oleg Cohen wrote:
>>>>>> Greetings,
>>>>>>
>>>>>> I am trying to run my Karaf application under JDK 11. I am getting the following exception:
>>>>>>
>>>>>> Caused by: java.lang.ClassNotFoundException: javax.annotation.PostConstruct cannot be found by org.ops4j.pax.web.pax-web-jsp_7.2.3
>>>>>>
>>>>>> It appears that the jigsaw module providing this package is not available in JDK 11. The suggestion is to use a dependency.
>>>>>>
>>>>>> Wondering if anybody ran into this and what a solution/workaround might be.
>>>>>>
>>>>>> Thank you!
>>>>>> Oleg
>>>>>>
>>>>>
>>>>> --
>>>>> Jean-Baptiste Onofré
>>>>> [hidden email]
>>>>> http://blog.nanthrax.net
>>>>> Talend - http://www.talend.com
>>>>
>
> --
> Jean-Baptiste Onofré
> [hidden email]
> http://blog.nanthrax.net
> Talend - http://www.talend.com

Reply | Threaded
Open this post in threaded view
|

Re: javax.annotation.PostConstruct issue when running with JDK11

jbonofre
You are welcome ! Always happy to help !

Regards
JB
Le 4 oct. 2018, à 15:31, Oleg Cohen <[hidden email]> a écrit:
Thank you, JB!

I got it to work successfully by adding lib/ext jar files to the classpath when launching Karaf (-classpath)

Best regards,
Oleg

On Oct 1, 2018, at 1:42 PM, Jean-Baptiste Onofré <[hidden email]> wrote:

Please let me know if you have any issue.

By the way, I'm preparing blog post + documentation update about how to
use Karaf on Java 10/11 and dealing with modules.

I created a Jira about that:

https://issues.apache.org/jira/browse/KARAF-5938

I also plan to add few examples about that (in karaf/examples).

Regards
JB

On 01/10/2018 19:18, Oleg Cohen wrote:
Thank you, JB! I will give it a try.

Best
Oleg

Sent from my iPhone

On Oct 1, 2018, at 11:57 AM, Jean-Baptiste Onofré <[hidden email]> wrote:

Hi Oleg,

You can add at Karaf level (in the startup) or via dynamic-import on pax
web.

Regards
JB

On 01/10/2018 17:44, Oleg Cohen wrote:
Thank you, JB!

In my case it is pax-web that can’t find the class, so I guess I need to add to ext lib. How can I add it? Should I do it at the JDK level or it is a mechanism in Karaf?

Thank you,
Oleg

On Oct 1, 2018, at 11:33 AM, Jean-Baptiste Onofré <[hidden email]> wrote:

Hi Oleg,

Correct, javax.annotation is available up to Java 10 (and even using
Java 10, the javax.annotation package has been splitted).

When using Java 11, you have to explicitly install either jsr305 or
javax.annotation jar files (it could be as private package of your
bundle, or ext lib).

Regards
JB

On 01/10/2018 17:14, Oleg Cohen wrote:
Greetings,

I am trying to run my Karaf application under JDK 11. I am getting the following exception:

Caused by: java.lang.ClassNotFoundException: javax.annotation.PostConstruct cannot be found by org.ops4j.pax.web.pax-web-jsp_7.2.3

It appears that the jigsaw module providing this package is not available in JDK 11. The suggestion is to use a dependency.

Wondering if anybody ran into this and what a solution/workaround might be.

Thank you!
Oleg


--
Jean-Baptiste Onofré
[hidden email]
http://blog.nanthrax.net
Talend - http://www.talend.com


--
Jean-Baptiste Onofré
[hidden email]
http://blog.nanthrax.net
Talend - http://www.talend.com